//PlagScan API usage example in JAVA
// REQUIRES httpcomponents-client-4.5.3 lib AND java-json lib
//Make sure to change access_token variable
//METHOD ADD USER
package api.code.example;

import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.List;
import org.apache.http.HttpEntity;
import org.apache.http.NameValuePair;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.client.methods.HttpRequestBase;
import org.apache.http.client.utils.URIBuilder;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.json.JSONException;
import org.json.JSONObject;


public class AddUser {
    static private String url = "https://api.plagscan.com/v3/users";

    public static int create(String token, String firstname, String lastname, String email, String username) throws IOException, URISyntaxException, JSONException{
    	return AddUser.create(token, firstname, lastname, email, username,-1);
    }
    public static int create(String token, String firstname, String lastname, String email) throws IOException, URISyntaxException, JSONException{
    	return AddUser.create(token, firstname, lastname, email, null,-1);
    }

    /**
     * @param String token - access token
     * @param String firstname - given name of the new user
     * @param String lastname - family name of the new user
     * @param String email - mail address of the new user
     * @param String username - unique username of the new user, can be null for using email
     * @param int groupID - group/department of the new user, can be null for users without group
     */    
    public static int create(String token, String firstname, String lastname, String email, String username, int groupID) throws IOException, URISyntaxException, JSONException{
    	
        //Create the client to make the request
        CloseableHttpClient client = HttpClients.createDefault();
        //Create the request method with the url
        HttpPost request = new HttpPost(url);

		if(username==null)
			username=email;
        //Adding the parameters 
        List<NameValuePair> params = new ArrayList<NameValuePair>(2);
        params.add(new BasicNameValuePair("firstname", firstname));
        params.add(new BasicNameValuePair("lastname", lastname));
        params.add(new BasicNameValuePair("email", email));
        params.add(new BasicNameValuePair("username", username));
        if(groupID>=0)
        	params.add(new BasicNameValuePair("deptID", ""+groupID));        
        request.setEntity(new UrlEncodedFormEntity(params, "UTF-8"));
                
        URIBuilder ub = new URIBuilder(request.getURI())
                .addParameter("access_token", token);
		URI uri = ub.build();
        ((HttpRequestBase ) request).setURI(uri);

        //Execute the request and get response
        CloseableHttpResponse response = client.execute(request);

        try{
          HttpEntity entity = response.getEntity();
          if(entity != null){
            String strResponse = EntityUtils.toString(entity);
            //We can show the response string directly
            //System.out.println(strResponse);
            //Also we can get the JSON object
            JSONObject json = new JSONObject(strResponse);
            int userPlagScanID = json.getJSONObject("data").getInt("userID");
            return userPlagScanID;
          }
        }finally{
          response.close();
        }
        return -1;
    }
    
}
