//PlagScan API usage example in JAVA
// REQUIRES httpcomponents-client-4.5.3 lib AND java-json lib
//Make sure to change access_token variable
//METHOD STATUS DOCUMENT
package api.code.example;

import java.io.File;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.List;
import org.apache.http.HttpEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpRequestBase;
import org.apache.http.client.utils.URIBuilder;
import org.apache.http.entity.ContentType;
import org.apache.http.entity.mime.MultipartEntityBuilder;
import org.apache.http.entity.mime.content.FileBody;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;
import org.json.JSONException;
import org.json.JSONObject;


public class GetStatus {
    static private String url = "https://api.plagscan.com/v3/documents/";

    /**
     * @param int docID - the PlagScan ID of the document to be queried
     */    
    public static String getStatus(int docID, String access_token) throws IOException, URISyntaxException, JSONException{
    	
        //Create the client to make the request
        CloseableHttpClient client = HttpClients.createDefault();
        //Create the request method with the url
        /*
        ****** MUST ADD THE ID OF THE DOCUMENT TO THE URL AND ADD "/status" ******
        */
        HttpGet request = new HttpGet(url+docID+"/status");

        //Adding to the URL the parameters (because it is a GET request)
        URI uri = new URIBuilder(request.getURI())
                .addParameter("access_token", access_token)
                .build();
        ((HttpRequestBase ) request).setURI(uri);

        //Execute the request and get response
        CloseableHttpResponse response = client.execute(request);

        try{
          HttpEntity entity = response.getEntity();
          if(entity != null){
            String strResponse = EntityUtils.toString(entity);
            //We can show the response string directly
            //System.out.println(strResponse);
            return strResponse;
          }
        }finally{
          response.close();
        }
        return "ERROR";
    }
    
    /**
     * @param integer state - value returned from the request
     */	
   	public static String mapState(int state){
   		if(state==0)
   			return "Document processed and ready to be checked.";
   		if(state==1)
   			return "Document in queue to be checked.";
   		if(state==2)
   			return "Document is currently being checked.";
   		if(state==3)
   			return "Document has been checked.";
   		if(state==4)
   			return "Document in queue to be checked.";
   		if(state==100)
   			return "Document in queue to be processed (extract, word count, etc).";
   		if(state==101)
   			return "Document in currently being processed (extract, word count, etc).";
   		if(state==254)
   			return "Document has been deleted.";
   		return "ERROR - undefined document state";   			
   	}

    
    /**
     * @param jsonResponse the raw JSON output returned by a get access token request
     */	
	public static int extractState(String jsonResponse) throws JSONException{
		JSONObject json = new JSONObject(jsonResponse);
		int state = json.getJSONObject("data").getInt("state");
		return state;
	}

}
