//PlagScan API usage example in JAVA
// REQUIRES httpcomponents-client-4.5.3 lib AND java-json lib
//Make sure to change access_token variable
//METHOD STATUS DOCUMENT
package api.code.example;

import java.io.File;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.List;
import org.apache.http.HttpEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPatch;
import org.apache.http.client.methods.HttpRequestBase;
import org.apache.http.client.utils.URIBuilder;
import org.apache.http.entity.ContentType;
import org.apache.http.entity.mime.MultipartEntityBuilder;
import org.apache.http.entity.mime.content.FileBody;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.NameValuePair;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;
import org.json.JSONException;
import org.json.JSONObject;


public class SetUserProp {
    static private String url = "https://api.plagscan.com/v3/users/";

    /**
     * @param int userID - the PlagScan ID of the user to be updated
     * @param String property - the property (https://api.plagscan.com/v3docs/#api-User-ChangeUserProperties)
     * @param String value - the new value to be set
     */    
    public static boolean setProperty(int userID, String property, String value, String access_token) throws IOException, URISyntaxException, JSONException{
    	
        //Create the client to make the request
        CloseableHttpClient client = HttpClients.createDefault();
        //Create the request method with the url
        HttpPatch request = new HttpPatch(url+userID);

        //Adding the parameters 
        List<NameValuePair> params = new ArrayList<NameValuePair>(2);
        params.add(new BasicNameValuePair(property, value));
        request.setEntity(new UrlEncodedFormEntity(params, "UTF-8"));


        //Adding to the URL the parameters 
        URI uri = new URIBuilder(request.getURI())
                .addParameter("access_token", access_token)
                .build();
        ((HttpRequestBase ) request).setURI(uri);

        //Execute the request and get response
        CloseableHttpResponse response = client.execute(request);

        try{
          HttpEntity entity = response.getEntity();
          if(entity != null){
            String strResponse = EntityUtils.toString(entity);
            //We can show the response string directly
            //System.out.println(strResponse);
            return true;
          }
        }finally{
          response.close();
        }
        return false;
    }

}
