import api.code.example.*;
import java.io.BufferedReader;
import java.io.File;
import java.io.FilenameFilter;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.TimeUnit;
import org.json.JSONException;
import org.json.JSONObject;

public class testUpload {

	public static String[] readLines(String filename){
	 ArrayList<String> Texte = new ArrayList();
		
		 try {
            String zeile;  
            File eingabeDatei = new File(filename);
            FileReader eingabeStrom = new FileReader(eingabeDatei);
            BufferedReader eingabe = new BufferedReader(eingabeStrom);
           
            while ((zeile = eingabe.readLine()) != null) { 
            	if(!zeile.startsWith("//"))
            		Texte.add(zeile.trim());
                            
               }
            
     	     }
          catch (IOException e) {
                 e.printStackTrace();
                  
                } 
          
          return (String[]) Texte.toArray(new String[Texte.size()]);
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws IOException, URISyntaxException, JSONException {
		
		System.out.println("PlagScan Test Uploader, Copyright PlagScan.com 2019");
		System.out.println("Provided without warranty of any kind, to the maximum extent allowed by local law.");
		String[] config = readLines("configuration.ini");
		GetAccessToken.client_id = config[0];
		if(GetAccessToken.client_id.equals("12345"))
			System.err.println("ERROR Seems like you did not change the default values in configuration.ini ?");
		GetAccessToken.client_secret = config[1];
		String token=GetAccessToken.extractToken(GetAccessToken.request());
		String source_directory = ".";
		String target_directory = "done";
		String filetypefilter = "txt";

		File[] files = new File(source_directory).listFiles(new FilenameFilter() {
    		public boolean accept(File dir, String name) {
        		return name.toLowerCase().endsWith(filetypefilter);
    		}
		});
		
		System.out.println("Found "+files.length+" files matching pattern "+filetypefilter+" in "+source_directory);

		File file = new File(target_directory);
		if(file.exists() && file.isDirectory()){
			System.out.println("Processed files will be moved to "+target_directory);
		}else{
			file.mkdir();
			System.out.println("Created directory "+file.getName()+", which will be target for processed files");
		}
		
		for(int i=0;i<files.length;i++){
		
			System.out.print("STEP 1: Uploading "+files[i]);
			String json = Submit.sendFile(source_directory + File.separator + files[i].getName(),token);
			int documentPlagScanID = Submit.extractDocId(json);
			System.out.println(" Done (ID : "+documentPlagScanID+")");
			
			if((target_directory!=null)&&(target_directory!="")&&(!target_directory.equals(source_directory))){				
				String target = target_directory + File.separator + files[i].getName();
				System.out.println("Moving to "+target);
				if(files[i].renameTo(new File(target))){
    				System.out.println(" Done");
    	   		}else{
    				System.out.println(" ERROR");
    	   		}
			}
			
			System.out.println("STEP 2: Waiting for conversion processing for "+files[i]+" ("+documentPlagScanID+")");
			int state=-1;
			do{
				//SHOULD USE CALLBACK AND WAIT FOR PUSH NOTIFICATION INSTEAD OF POLLING HERE!
				System.err.println("SHOULD USE CALLBACK AND WAIT FOR PUSH NOTIFICATION INSTEAD OF POLLING HERE!");
				try{ //need to pace requests or API will block
					TimeUnit.SECONDS.sleep(3); 
				}catch(Exception e){}
				String jsonState = GetStatus.getStatus(documentPlagScanID,token);
				state = GetStatus.extractState(jsonState);
				System.err.println(GetStatus.mapState(state));
			}while(state>9);

			System.out.println("STEP 3: Start plagiarism check for "+files[i]+" ("+documentPlagScanID+")");
			json = Check.start(documentPlagScanID,token);			
			if(json.indexOf("ERROR")>=0){
				System.err.println("Exit due to ERROR!");
				System.exit(1);
			}			
			
			System.out.println("STEP 4: Waiting for plagiarism check completion for "+files[i]+" ("+documentPlagScanID+")");
			do{
				//SHOULD USE CALLBACK AND WAIT FOR PUSH NOTIFICATION INSTEAD OF POLLING HERE!
				System.err.println("SHOULD USE CALLBACK AND WAIT FOR PUSH NOTIFICATION INSTEAD OF POLLING HERE!");
				try{ //need to pace requests or API will block
					TimeUnit.SECONDS.sleep(3); 
				}catch(Exception e){}
				String jsonState = GetStatus.getStatus(documentPlagScanID,token);
				state = GetStatus.extractState(jsonState);
				System.err.println(GetStatus.mapState(state));
				if(state==0){
					System.err.println("ERROR: Check could not be initiated for document "+documentPlagScanID+" - is the account activated and has credits?");
					System.exit(1);
				}							
			}while(state!=3);

			System.out.println("STEP 5: Get check result for "+files[i]);
			json = Retrieve.getStatistics(documentPlagScanID,token);			
			
		}//end for loop	over files	

    }
    
}
