import api.code.example.*;
import java.io.BufferedReader;
import java.io.File;
import java.io.FilenameFilter;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.TimeUnit;
import org.json.JSONException;
import org.json.JSONObject;

public class testUser {

	public static String[] readLines(String filename){
	 ArrayList<String> Texte = new ArrayList();
		
		 try {
            String zeile;  
            File eingabeDatei = new File(filename);
            FileReader eingabeStrom = new FileReader(eingabeDatei);
            BufferedReader eingabe = new BufferedReader(eingabeStrom);
           
            while ((zeile = eingabe.readLine()) != null) { 
            	if(!zeile.startsWith("//"))
            		Texte.add(zeile.trim());
                            
               }
            
     	     }
          catch (IOException e) {
                 e.printStackTrace();
                  
                } 
          
          return (String[]) Texte.toArray(new String[Texte.size()]);
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws IOException, URISyntaxException, JSONException {
		
		System.out.println("PlagScan Test User Operations, Copyright PlagScan.com 2019");
		System.out.println("Provided without warranty of any kind, to the maximum extent allowed by local law.");
		String[] config = readLines("configuration.ini");
		GetAccessToken.client_id = config[0];
		if(GetAccessToken.client_id.equals("12345"))
			System.err.println("ERROR Seems like you did not change the default values in configuration.ini ?");
		GetAccessToken.client_secret = config[1];
		String token=GetAccessToken.extractToken(GetAccessToken.request());
		
		int randNum = (int)(java.lang.Math.random()*9999999);
		System.out.println("Generating user...");
		int newUserId = AddUser.create(token, "John"+randNum, "Doe"+randNum, randNum+"@java-email-test.com");
		if(newUserId<=0){
			System.err.println("FAILED creating new user!");
			System.exit(1);
		}
		
		String jsonResponse= GetUserInfo.getData(newUserId, token);
		System.out.println("User generated: "+jsonResponse);
		
		JSONObject json = new JSONObject(jsonResponse);		
		int citePolicy = json.getJSONObject("data").getInt("citePolicy");
		System.out.println("User's citePolicy: "+citePolicy);
		
		if(citePolicy>0) citePolicy=0; else citePolicy++;		
		System.out.println("Setting user's citePolicy to: "+citePolicy);
		
		if(SetUserProp.setProperty(newUserId, "cite", ""+citePolicy, token)){
			jsonResponse= GetUserInfo.getData(newUserId, token);
			JSONObject newConfig = new JSONObject(jsonResponse);		
			int newCitePolicy = newConfig.getJSONObject("data").getInt("citePolicy");
			System.out.println("Returned new value after update: "+newCitePolicy);
		}else{
			System.err.println("FAILED setting new value!");
			System.exit(1);
		}

    }
    
}
